<script setup lang="ts">
import router from '@/router'
import { type Ref, ref, nextTick } from 'vue'
import { type User } from '@/types/User'
import { useMessageStore } from '@/stores/message'
import { useMembersStore } from '@/stores/member'

const messageStore = useMessageStore()
const memberStore = useMembersStore()

const type = ref('password')

const dialog = ref(false)
const email = ref('')
const username = ref('')
const pass = ref('')
const passCon = ref('')
const name = ref('')
const tel = ref('')
const gender = ref('')
const img = ref('noimg.jpg')

async function Register() {
  if (email.value !== '') {
    if (username.value !== '') {
      if (pass.value !== '') {
        if (passCon.value !== '') {
          if (name.value !== '') {
            if (tel.value !== '') {
              if (gender.value !== '') {
                if (passCon.value == pass.value) {
                  memberStore.editedMember.email = email.value
                  memberStore.editedMember.username = username.value
                  memberStore.editedMember.password = pass.value
                  memberStore.editedMember.name = name.value
                  memberStore.editedMember.tel = tel.value
                  memberStore.editedMember.gender = gender.value
                  await memberStore.registerMember()
                  closeDialog()
                } else {
                  messageStore.errorDialog = true
                }
              } else {
                messageStore.errorDialog = true
              }
            } else {
              messageStore.errorDialog = true
            }
          } else {
            messageStore.errorDialog = true
          }
        } else {
          messageStore.errorDialog = true
        }
      } else {
        messageStore.errorDialog = true
      }
    } else {
      messageStore.errorDialog = true
    }
  } else {
    messageStore.errorDialog = true
  }
}

function changeType() {
  if (type.value == 'password') {
    type.value = ''
  } else {
    type.value = 'password'
  }
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}
</script>

<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" persistent width="1100" height="500">
      <template v-slot:activator="{ props }">
        <v-btn variant="outlined" color="white" v-bind="props" height="40px" width="150px">
          Register
        </v-btn>
      </template>

      <v-row >
        <v-img height="500" width="550" src="\src\assets\Login\image2.jpg"> </v-img>

        <v-card width="480" height="495" color="white">
          <v-card-title Align="center">
            <h3 style="font-size: 40px; margin-top: 30px">Register</h3>
          </v-card-title>
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="6" md="13" class="mx-auto">
                  <v-text-field
                    label="Username"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-account"
                    v-model="username"
                  ></v-text-field>
                </v-col>
                <v-col cols="6" md="13" class="mx-auto">
                  <v-text-field
                    label="Email"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-email"
                    v-model="email"
                  ></v-text-field>
                </v-col>
                <v-col cols="6" md="13" class="mx-auto">
                  <v-text-field
                    label="Password"
                    :type="type"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-lock-outline"
                    v-model="pass"
                    append-inner-icon="mdi-eye-outline"
                    @click:append-inner="changeType()"
                  >
                  </v-text-field>
                </v-col>
                <v-col cols="6" md="13" class="mx-auto">
                  <v-text-field
                    label="Confirm Password"
                    :type="type"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-lock-outline"
                    v-model="passCon"
                    append-inner-icon="mdi-eye-outline"
                    @click:append-inner="changeType()"
                  ></v-text-field>
                </v-col>
                <v-col cols="4" md="13" class="mx-auto">
                  <v-text-field
                    label="Name"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-account"
                    v-model="name"
                  ></v-text-field>
                </v-col>
                <v-col cols="4" md="13" class="mx-auto">
                  <v-text-field
                    label="Tel"
                    required
                    variant="outlined"
                    clearable
                    prepend-inner-icon="mdi-phone"
                    v-model="tel"
                  ></v-text-field>
                </v-col>
                <v-col cols="4" md="13" class="mx-auto">
                  <v-combobox
                    v-model="gender"
                    label="Gender"
                    variant="outlined"
                    prepend-inner-icon="mdi-gender-male-female"
                    required
                    :items="[
                      { title: 'Male', value: 'Male' },
                      { title: 'Female', value: 'Female' },
                      { title: 'Others', value: 'Others' }
                    ]"
                    :return-object="false"
                  ></v-combobox>
                </v-col>
              </v-row>
            </v-container>
            <small class="text-caption text-decoration-none text-blue-lighten-1"
              >Please enter your infomation.</small
            >
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="blue-lighten-1"
              append-icon="mdi-close"
              variant="outlined"
              class="list-item-hover"
              @click="dialog = false"
            >
              Close
            </v-btn>
            <v-btn
              color="blue-lighten-1"
              append-icon="mdi-arrow-right"
              variant="flat"
              class="list-item-hover"
              @click="Register()"
            >
              Register
            </v-btn>

            <v-dialog v-model="messageStore.errorDialog" width="500px">
              <v-card>
                <br />
                <v-img
                  style="margin-left: 230px"
                  :width="40"
                  src="\src\assets\Login\icon.png"
                ></v-img>
                <v-spacer></v-spacer>
                <v-card-title align="center" class="text-h5">Login Failed</v-card-title>
                <v-card-title align="center" class="text-h10">
                  This action cannot be undone.<br />
                  You need to put correct password.
                </v-card-title>
                <v-spacer></v-spacer>
                <div align="center">
                  <div
                    style="
                      margin: 0 auto;
                      max-width: 400px;
                      border: 1px solid #dfe1e6;
                      border-radius: 5px;
                      margin-top: 10px;
                    "
                  >
                    <v-btn
                      block
                      color="primary"
                      variant="text"
                      @click="messageStore.closeErrorLogin()"
                    >
                      Cancel
                    </v-btn>
                  </div>
                </div>
                <v-spacer></v-spacer>
                <br />
              </v-card>
            </v-dialog>
          </v-card-actions>
        </v-card>
      </v-row>
    </v-dialog>
  </v-row>
</template>

<style scoped>
.list-item-hover:hover {
  transform: scale(1.03); /* Increase size by 5% on hover */
  box-shadow:
    0 4px 6px rgba(0, 0, 0, 0.1),
    0 1px 3px rgba(0, 0, 0, 0.08); /* Add a subtle box shadow */
}
</style>
